QGIS Application - Bug report #12146
Join tables are not shown in form defined by Drag and drop designer
2015-02-07 03:52 AM - Seb Radzimski

Status: Closed

Priority: Normal

Assignee:

Category: Forms

Affected QGIS version:2.6.0 Regression?: No

Operating System: Windows Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 20340
Description

Hi there!

| found a problem in QGIS 2.6.1 while working with joined layers and showing them in forms definded in 'drag and drop designer'. In an
attached project | joined 2 layers ('two' is joined into 'one'). Using 'drag and drop designer' | defined simple form to display layers
attributes. The problem is that | don't see any attributes of layer 'two' when selecting layer 'one’ feature in that form. If | change editor to
'autogenereted' | see all attributes as in table manager. But when | defined that form (in 'drag and drop') everything was working
fine...until | reload the project.

I hope you understand what | mean but please check attached project. If you open it and select any line on a layer 'one' you wond be able
to see any attributes of joined layer 'two' while using drag and drop form. But in attribute table everything will be fine as when you change
editor for autogenerate.

Please let me know if that is a bug or | am doing something wrong.

Cheers!

Associated revisions

Revision d8b715ab - 2015-02-22 11:24 PM - Jiirgen Fischer

attribute form: lookup attribute fields by name. joined layers might be unavailable at load time (fixes #12146)

Revision 61555f59 - 2015-02-22 11:25 PM - Juirgen Fischer

attribute form: lookup attribute fields by name. joined layers might be unavailable at load time (fixes #12146)

History

#1 - 2015-02-09 12:28 AM - Giovanni Manghi
- File jojn_form.png added
- Status changed from Open to Feedback

it seems to work on master, see attached image. Can you test and report back? thanks.

#2 - 2015-02-12 02:13 PM - Seb Radzimski
- File 02.png added
- File 01.png added

Thanks Giovanni! | found this problem on Windows 7 and 8 but | will check that on Ubuntu as well. Please have a look on my attached images (01.png that
is the same project). Attributes of joined table are shown in 'Attribute table' but not shown in 'two' tab, in a form made by 'Drag and drop'. Well, when you
are joining tables you can see everything, but after saving and reloading the project, columns of that joined table disappeared from tab 'two'. In my bigger
project | join two postgresql tables with many columns. In a similar tab you can see that there is many columns (there is a side bar on 02.png image) but
there is no attributes. If | re-define that join (in layer properties) everything will be OK, but after saving and reloading the project, columns from joined table
disappears. | checked that sytuation on many Windows computers (stand alone instalation or OSGeo4W) and it happens everywhere.

| hope you will be able to confirm that bug :)

Cheers!

#3 - 2015-02-12 11:55 PM - Giovanni Manghi

Seb Radzimski wrote:

Thanks Giovanni! | found this problem on Windows 7 and 8 but I will check that on Ubuntu as well. Please have a look on my attached images
(01.png that is the same project). Attributes of joined table are shown in "Attribute table' but not shown in 'two' tab, in a form made by 'Drag and
drop'. Well, when you are joining tables you can see everything, but after saving and reloading the project, columns of that joined table disappeared
from tab 'two'. In my bigger project | join two postgresql tables with many columns. In a similar tab you can see that there is many columns (there is
a side bar on 02.png image) but there is no attributes. If | re-define that join (in layer properties) everything will be OK, but after saving and reloading
the project, columns from joined table disappears. | checked that sytuation on many Windows computers (stand alone instalation or OSGeo4W) and
it happens everywhere.

| hope you will be able to confirm that bug :)

Cheers!

please test qgis master.

#4 - 2015-02-18 02:50 AM - Seb Radzimski
- File 04.png added
- File 01.png added
- File 02.png added
- File 03.png added
- File 00.png added

| have checked it on QGIS 2.7.0-100 master (OSGeo4W) or on Ubuntu 12.04 and | have the same problem.

For two layers (one.shp and two.shp) | create a join in one.shp (file properties) like on pic 01. Then | create in Drop and Drop editor a form as on pic 02.
And everything works fine (pic 03) until | save the project and reload it. Then | don't see any attributes in of joined table (pic 04). | have to open layer
one.shp properties and click in Fields menu on tables, click OK and it works again! | know that is a strange thing but it happens on many computers
(Windows/Ubuntu) with QGIS 2.6.1 or 2.7 master. For me it looks like some options are missing in qgs file, so after reloading project, QGIS doesn't know
how to display attributes of joined tables in forms made in Drag and Drop editor. Please check it for me, if after saving and reloading project you have the

same problem.

#5 - 2015-02-18 11:38 AM - Jiirgen Fischer
- Status changed from Feedback to Closed
- Resolution set to fixed/implemented

should be fixed in commit:39d3765

#6 - 2015-02-22 09:08 AM - Seb Radzimski
- File 22.png added

Well, | have checked it again on QGIS 2.8 and 2.9.0 master and | still get the same bug. | don't know if there is something wrong in all my computers or

maybe I'm doing something wrong, but | found in this kind of sytuation QGIS 2.2 says "Error: Field doesn not exist in database" (pic 22). Of course that is

happen after saving and reloading poroject. And like before, it is enought to open layer properties and click on field menu to make everything working fine.

Regards!

#7 - 2015-12-23 12:38 AM - Artur Lill
- Assignee set to Jirgen Fischer

| confirm that this bug is Not Fixed Yet:

1. Attribute editor layout is set to Drag and Drop designer.

2.1 added joined table attribute named ATR1 into form.

3. Using tool "Identify Features" now | see also this added attribute ATR1 on form.

After saving and reloading project and repeating just step 3

attribute ATR1 is not seen on form anymore.

#8 - 2015-12-23 01:13 AM - Giovanni Manghi
- Status changed from Closed to Reopened

- Resolution deleted (fixed/implemented)

- Assignee deleted (Jirgen Fischer)

- Target version deleted (Version 2.8)

#9 - 2015-12-23 03:00 AM - Artur Lill

Just tested with QGIS 2.12.2 and it looks much better now:

now attributes are shown on form but labels are missing.

#10 - 2016-06-09 09:08 PM - Nyall Dawson
- Status changed from Reopened to Closed

- Resolution set to fixed/implemented

Not reproducable on current master
